<template>
    <div class="changePassword">
        <a class="backBtn" @click="onBack">
            <md-icon class="md-primary">chevron_left</md-icon>
            <span class="md-title">กลับ</span>
        </a>
        <h1>เปลี่ยนรหัสผ่าน</h1>
        <div class="changePasswordForm">
            <md-field :class="currentPasswordError">
                <label>รหัสผ่านปัจจุบัน</label>
                <md-input v-model="currentPassword" type="password" required></md-input>
                <span class="md-error" v-if="currentPasswordRequired">ต้องป้อนรหัสผ่านปัจจุบัน</span>
            </md-field><br>

            <md-field :class="newPasswordError">
                <label>รหัสผ่านใหม่</label>
                <md-input v-model="newPassword" type="password" required></md-input>
                <span class="md-error" v-if="newPasswordRequired">ต้องป้อนรหัสผ่านใหม่</span>
                <span class="md-error" v-else-if="newPasswordLength">รหัสผ่านต้องยาวมากกว่า 8 ตัวอักษร</span>
            </md-field>

            <md-field :class="checkNewPasswordError">
                <label>ยืนยันรหัสผ่านใหม่</label>
                <md-input v-model="checkNewPassword" type="password" required></md-input>
                <span class="md-error" v-if="checkNewPasswordRequired">ต้องป้อนยืนยันรหัสผ่าน</span>
                <span class="md-error" v-else-if="checkNewPasswordMatch">รหัสผ่านไม่ตรงกัน</span>
            </md-field><br>

            <md-button class="md-raised md-primary changeBtn" @click="changePassword">ยืนยัน</md-button>
        </div>
    </div>
</template>

<script>
export default {
    name: 'ChangePassword',
    metaInfo: {
        title: 'เปลี่ยนรหัสผ่าน'
    },
    data() {
        return {
            currentPassword: '',
            newPassword: '',
            checkNewPassword: '',

            currentPasswordRequired: false,
            newPasswordRequired: false,
            newPasswordLength: false,
            checkNewPasswordRequired: false,
            checkNewPasswordMatch: false,
        }
    },
    methods: {
        onBack() {
            this.$router.replace('/profile').catch(()=>{})
        },
        changePassword() {
            if(this.currentPassword === '') this.currentPasswordRequired = true
            else this.currentPasswordRequired = false 

            if(this.newPassword === '') this.newPasswordRequired = true
            else this.newPasswordRequired = false

            if(this.newPassword.length < 8) this.newPasswordLength = true
            else this.newPasswordLength = false

            if(this.checkNewPassword === '') this.checkNewPasswordRequired = true
            else this.checkNewPasswordRequired = false

            if(this.newPassword !== this.checkNewPassword) this.checkNewPasswordMatch = true
            else this.checkNewPasswordMatch = false
        }
    },
    computed: {
        currentPasswordError() {
            if(this.currentPasswordRequired === true) return {'md-invalid': this.currentPasswordRequired}
        },
        newPasswordError() {
            if(this.newPasswordRequired === true) return {'md-invalid': this.newPasswordRequired}
            else if(this.newPasswordLength === true) return {'md-invalid': this.newPasswordLength}
        },
        checkNewPasswordError() {
            if(this.checkNewPasswordRequired === true) return {'md-invalid': this.checkNewPasswordRequired}
            else if(this.checkNewPasswordMatch === true) return {'md-invalid': this.checkNewPasswordMatch}
        }
    }
}
</script>

<style lang="scss" scoped>
h1 {
    font-size: 2.5rem;
}

.backBtn {
    display: inline-flex;
    align-items: center;
}
.backBtn:hover {
    cursor: pointer;
    text-decoration: none;
}

.changePasswordForm {
    width: 100%;
    display: flex;
    flex-direction: column;
    justify-content: center;
    align-items: center;
}

.changeBtn {
    width: 100%;
    padding: 0;
    margin: 0;
    margin-top: 1rem;
}
</style>